/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: SCOPE_IDPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the SCOPE_IDPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=SCOPE_ID.class)
public class SCOPE_IDPointer extends StructurePointer {

	// NULL
	public static final SCOPE_IDPointer NULL = new SCOPE_IDPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected SCOPE_IDPointer(long address) {
		super(address);
	}

	public static SCOPE_IDPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static SCOPE_IDPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static SCOPE_IDPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new SCOPE_IDPointer(address);
	}

	public SCOPE_IDPointer add(long count) {
		return SCOPE_IDPointer.cast(address + (SCOPE_ID.SIZEOF * count));
	}

	public SCOPE_IDPointer add(Scalar count) {
		return add(count.longValue());
	}

	public SCOPE_IDPointer addOffset(long offset) {
		return SCOPE_IDPointer.cast(address + offset);
	}

	public SCOPE_IDPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public SCOPE_IDPointer sub(long count) {
		return SCOPE_IDPointer.cast(address - (SCOPE_ID.SIZEOF * count));
	}

	public SCOPE_IDPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public SCOPE_IDPointer subOffset(long offset) {
		return SCOPE_IDPointer.cast(address - offset);
	}

	public SCOPE_IDPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public SCOPE_IDPointer untag(long mask) {
		return SCOPE_IDPointer.cast(address & ~mask);
	}

	public SCOPE_IDPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return SCOPE_ID.SIZEOF;
	}

	// Implementation methods

	// U32:4 Level
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_LevelOffset_", declaredType="U32:4")
	public UDATA Level() throws CorruptDataException {
		return getU32Bitfield(SCOPE_ID._Level_s_, SCOPE_ID._Level_b_);
	}

	// U32 Value
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ValueOffset_", declaredType="U32")
	public UDATA Value() throws CorruptDataException {
		return new U32(getIntAtOffset(SCOPE_ID._ValueOffset_));
	}

	// U32 Value
	public UDATAPointer ValueEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(SCOPE_ID._ValueOffset_));
	}

	// U32:28 Zone
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ZoneOffset_", declaredType="U32:28")
	public UDATA Zone() throws CorruptDataException {
		return getU32Bitfield(SCOPE_ID._Zone_s_, SCOPE_ID._Zone_b_);
	}

}
